C#ATIA

↑タイトル詐欺 主にCATIA V5 の VBA

VBA

CATPart内エラー時のUpdateObject

こちらでコメント頂いた 「GetMeasurableはUpdate出来ないと長さも取得できそうにありません」 について、解決されたようですが、試しているうちに知らなかった事に 出くわした為、記載しておきます。 選択した円弧の長さを表示1 - C#ATIA テストしたデータはこん…

アクティブCATPartを、Igesファイルにバッチ変換

ちょっと業務上欲しくなったので、CATPartファイルをIgesに変換する為の マクロを作成しました。" マクロにする必要ある? " と思った方、正解です。単に変換するだけであれば、必要性を感じないのですが、オプションの こちらの部分を変更しソリッドとサーフェスで二回変換してます…

UpdateObjectとComputeの違い

こちらで教えて頂いた、Computeメソッド UpdateとUpdateObject - C#ATIAこちらで試した際は気が付かなかったのですが、 スピードテスト5 - C#ATIAPartクラスのUpdateObjectメソッドは各HybridShapeクラスのComputeメソッドを 呼び出しているだけなのかな? と思っていたので…

ボディの外側をマクロで判断する

以前、3次元測定機の測定結果(CSV)をCATIAに取り込み、 実物とCADデータを差を調整しながらモデリングを行った事があったのですが、 大量の点をイチイチ測定する手間が非現実的なため、誤差を測定する為の マクロを作成し作業をしたことが有ります。単に 点 - ボディ 間の…

スピードテスト5

一応、こちらの続きです。 http://kantoku.hatenablog.com/entry/2015/04/15/195513前回のコメントで、"HybridShapeクラスのComputeメソッドでもアップデート出来るよ" と imihitoさんに教えていただき、少し速くなりそうな気がしたので、 こちらのコードを元に試してみまし…

UpdateとUpdateObject

"マクロで作成した面の色を変更したけど、上手く反映されない" と言った内容の御質問を頂きました。このような状態のデータで、オフセット面を作成する操作の マクロを記録しました。 'vba Sub CATMain() Dim partDocument1 As PartDocument Set partDocument1 = CATIA.Ac…

クリックした面に3Dな矢印と注記を作る

こちらの続きです。 3Dな注記の位置を制御出来ているっぽい(条件付き) - C#ATIAやっと完成しました。 注記位置については前回通り、条件付となりますが結構満足してます。 'vba sample_CreateArrow_ver0.0.3 using-'ver0.0.10' 'クリックした面に矢印を作成-注記…

クリックした面に3Dな矢印を作る

タイトルが異なりますが、こちらの続きです。 クリックした面に法線を作成する - C#ATIAこちらでコメント頂いている矢の部分ですが、 昨日自宅で、どの様な定義をすれば良いのか思いついたので コードを作成してみました。 (このような事は案外、PCの前に居ない時に思いつ…

マクロで干渉レポートを作成する

こちらのコメントに記載した、マクロで干渉レポートを作成するサンプルを 作成しました。 クリックした面に法線を作成する - C#ATIA コードはこちら。 'vba sample_ClashReport_ver0.01 using-'ver0.0.10' '指定した2つのプロダクトの干渉チェックをします Option Explicit Sub CATMain…

Viewpoint3Dで表示を動かす2

こちらのコメントで御質問頂いた "画面中心に表示させる" 方法のサンプルです。 クリックした面に法線を作成する - C#ATIA と言っても、過去にテストしたコードを64bitで動くように 修正しただけなのですが・・・ Viewpoint3Dで表示を動かす - C#ATIA 'vba test_Viewpoint3D ver…

読み取り専用でファイルを開く2

昨日、imihitoさんからのアドバイスを利用するために書き換えてみました。 読み取り専用でファイルを開く1 - C#ATIAVBA.FileSystem.SetAttr/GetAttr関数を利用して進めていたのですが、 ファイルの存在をチェックや拡張子を取得する関数類がVBA.FileSystemには 存在していな…

読み取り専用でファイルを開く1

"読み取り専用でファイルを開きたい" と御質問を頂きました。 過去に探した事が有り、"Unofficial CATIA User Forum" にも 記載したのですが・・・ 生憎、ソースコードの管理が悪く サンプルが見つかりませんでした。結論としては、CATIAのマクロでドウコウでは無く、FileSystemOb…

クリックした面に法線を作成する

こちらでコメント頂いたのですが、時間がナカナカ確保できずに サンプルを作れませんでした。3Dの文字モデリングマクロ8 - C#ATIA正直な所、完成した状態がイメージし切れていないため、クリックした 面のクリックした位置に法線を作成するマクロを作成してみました。 'vba sample_Cre…

サーフェスの色をボディに反映する2

こちらの続きですが、タイトル名がふさわしくないです。サーフェスの色をボディに反映する - C#ATIAtakashiさんからコメントを頂き、早速ご要望を反映してみました。 'vba sample_ApplyColor_ver0.0.2 using-'KCL0.0.10' '指定した形状セット(ボディ)の面の色をボディ(形状セット)…

環境変数 CAT_VBAIsOutProc

これ知りませんでした。COE : Forums : CAT_VBAIsOutProc確かにVBA6(32bit)からVBA7(64bit)に移行した際、 動かないマクロが幾つかありました。(KCLも)起動するCATIAの環境変数にこれを追加することで VBA7でも32bitとして実行できるようです。何れは64bitとし…

GSMGetObjectFromReference

COEにこんな記載が http://www.coe.org/p/fo/st/thread=29679リファレンスからオブジェクトを取得する関数。 使わないので忘れていたのですが、利用価値が無いわけじゃ 無いと思ってます。ドキュメントに記載されていないので、忘れるわけです・・・。 と言う理由での覚書。

選択した円弧の長さを表示2

こちらの続きです。 選択した円弧の長さを表示1 - C#ATIAもう一つ方法があり、パラメータと式を利用した方法です。 'vba test_Circle_Length_Formula 'using-'KCL0.0.10' '円弧の長さを表示-式利用 Option Explicit Sub CATMain() 'ドキュメントのチェック If Not CanExec…

選択した円弧の長さを表示1

ちょっと相談?を頂いたので、久々にCATIAのマクロを書いてみました。選択した3D円弧の長さを表示するだけのものです。 極端な話、こちらの物を流用しただけです。 線を選択しつつ、合計長さを表示する - C#ATIA 'vba test_Circle_Length 'using-'KCL0.0.10' '円…

PowerMillに同位置の作業平面を作る

加工する際、世の中の方々は加工原点をどうやって決めているんでしょうか? 部品の原点が決まっているようであれば、そこを原点にするのかも知れない のですが、基準まで加工して作る場合は・・・バイスを使用していたら材料の 上側の左奥(か、右奥・・・わかりにくい…

Drawのテキストサイズを変更する

"Drawのテキストサイズを変更したけど反映されない?" のような ご相談を頂きましたが、ちょっと状況がわからないので、 現象を再現できないでいます。クリックしたテキストのサイズを2倍にするだけのテストコードです。 'vba test_DrawTextSize_Double 'using-'KCL0.0.10' 'DrawTe…

2Dコンポーネントを展開する

こちらの続きです。 指定した2D要素を、指定した原点位置でコピペする - C#ATIA 予告していた、2Dコンポーネント(2D構成要素)を展開するマクロです。アクティブなDrawシート全てのビュー内(メイン・背景・ロック・非表示)にある 2Dコンポーネントが対象です。 'vba sample_Comp2DExplode ver…

2D曲線の折れ線化を利用し、重複線の選択2

こちらの続きです。 2D曲線の折れ線化を利用し、重複線の選択1 - C#ATIA 昨日の4分木ライブラリを利用して、前回の重複線を選択した状態にする マクロを改良しました。 'vba test_Select_Overlap_Curve2D ver0.0.2 'using-'KCL0.09' -'KCL_Quadtree0.0.1' '指定ビュー…

流用して、4分木る 3

こちらの続きです。 流用して、4分木る 2 - C#ATIAやっと、2度と見たくない程の汚いコードになってしまいましたが 組み合わせの効率化を促す、線形4分木が出来ました。"KCL_Quadtree.bas" と言う名称の標準モジュールとします。 'KCL' と、先日のDotNET Framework …

ArrayListラッパークラスをお借りしてみる2

VBA

こちらの続きです。 ArrayListラッパークラスをお借りしてみる - C#ATIAイロイロとコメントで教えて頂いたので、こちらの.NETFramework_ArrayListの ラッパークラスに AarrayListをvbaで使いやすいようにラップしてみた : 趣味のプログラムあれこれこちらを反映してみました。 Wr…

指定した2D要素を、指定した原点位置でコピペする

DXF(2D)データを受け取って3Dにモデリングする作業は、ほぼ無いのですが 大まかな形状を作成したい時が偶にあり、行います。DXFをインポートして手っ取り早く、3Dに貼り付けたいのですが困るのが 原点合わせです。 Draw側で原点をあわせて3Dにベタッと貼り付けるか? 3D…

インプロセス実行時、一部をアウトプロセスで実行 2

こちらの続きです。 インプロセス実行時、一部をアウトプロセスで実行 - C#ATIA 呼び出すだけではなく、戻り値も取得できるものか? 確認して いなかったので前回のコードを修正し、テストすることにしました。 'vba using-'KCL0.09' Sub CATMain() '*** VBE準備 *** Dim VbPj…

流用して、4分木る 2

VBA

こちらの続きです。 流用して、4分木る1 - C#ATIA オリジナルのモートン順序の番号とY軸が逆になってしまう部分ですが、 何となくですが、自分なりの考えです。番号を求める際、オリジナルのコードではこんな式で計算した後に、 関数に投げています。 // 座標→線形4分木要…

インプロセス実行時、一部をアウトプロセスで実行

KCLには言語判定の関数 "GetLanguage" 関数を入れているのですが、 最近になって打率が悪いことに気が付きました。 判定できない原因の一つが、マクロ自身をインプロセスで実行した際に ステータスバーの文字を取得する前に、判定しているような気がしています。その為、イン…

流用して、4分木る1

VBA

こちらで遅かった為の改善策を模索中です。 2D曲線の折れ線化を利用し、重複線の選択1 - C#ATIA曲線の折れ線化については、後回しにして4分木に挑戦です。 8分木の計算式変更して、次元を一つ落とせば良いのだろうと 思っているのですが。 'vba test_Quadtre…

2D曲線の折れ線化を利用し、重複線の選択1

こちらの続きです。 2D曲線の折れ線化 - スプライン - C#ATIA 2DCADであれば比較的、重複線削除の機能を持ったものもあると思います。 AutoCADであればこんな機能です。 OVERKILL[重複オブジェクト削除] (コマンド) | AutoCAD | Autodesk Knowledge Network僕が…

2D曲線の折れ線化 - スプライン

こちらの続きです。 2D曲線の折れ線化 - 円弧 - C#ATIA 前回のもののスプライン版です。円弧版同様に、3DからリンクしたものはNGです。 'vba test_Curve2Polyline using-'KCL0.09' '2Dスプラインの折れ線化 Option Explicit '*** 設定 *** Private Const m_PolyTol = 0.…

2D曲線の折れ線化 - 円弧

過去に作った2Dの重複線削除マクロを修正して、再度Upする意欲が 出て来たので、しばらくはこれに取り組みたいと思っています。昔のコードに4分木を適用するのが結構面倒な事になりそうな為、 ほぼ作り直しです。 当時、重複線を判断する際、直線・円弧は何となく…

単独な3D曲線の取得する2

こちらの続きです。 単独な3D曲線の取得する1 - C#ATIA 前回は総当りの非常に効率の悪い物でしたが、線形8分木による スクリーニング処理を利用し単独な3D曲線を検索するように修正しました。まずはCATMainを持つ標準モジュール "FindSingle3DCurve.bas" です。 'vba F…

不覚にも、KCLのご利用をお考えの方へ

非常に個人的に作成している CATVBA用ライブラリ なのですが、サンプルとして 掲載しているマクロを利用する際には必要となる為、今更ながらご説明です。例えばこちらの場合ですが、 単独な3D曲線の取得する1 - C#ATIA サンプルコードのヘッダ部分を確認してください。 (忘れ…

端点一致を探る、組み合わせテスト11

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト10 - C#ATIA 前回の物を実装する為に書き換えました。 'vba 'モートン順序を利用した8分木空間分割の為のクズコード4 Option Explicit Private Const CLINER8TREEMANAGER_MAXLEVEL = 7 '有効空間分割最大レベル P…

端点一致を探る、組み合わせテスト10

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト9 - C#ATIA 昨日の悩みが全て解消するような、良い方法を思い付きました。 時間が無い為、先にコードです。 'vba 'モートン順序を利用した8分木空間分割の為のクズコード3 Option Explicit Private Const CLINER8…

端点一致を探る、組み合わせテスト9

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト8 - C#ATIA 忙しいので進められる状態では無いのですが、考えもまとまらない為 コード無しです。最初は端点同士の比較の為、空間を跨ぐ事は無いなぁ と考えていました。 今回の様に数値を比較する際、イコール…

端点一致を探る、組み合わせテスト8

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト7 - C#ATIA 残されたもう一つのバグがわかりました。 今後の事を考え、オリジナルとは異なる処理をさせていた部分の 渡すべき引数を間違えていました・・・。 "符号なしInt を Long型で代用" とか "右ビットシフト関…

端点一致を探る、組み合わせテスト7

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト6 - C#ATIA 一ヶ所だけバグを発見しました。 こちらのコードですが 端点一致を探る、組み合わせテスト3 - C#ATIAGetPointElem関数内のGet3DMortonNumber関数を利用する際の引数部分の 計算式を CByte((p(0…

端点一致を探る、組み合わせテスト6

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト5 - C#ATIA 説明をきちんと読んでませんでした。>"分割レベルL=2 最小を16番 最大を23番" では >"親空間の2番" なのですが、実行すると "親空間の3番" に・・・。と前回は書いたのですが、" 3 " が戻ってき…

単独な3D曲線の取得する1

こちらの続きです。 端点一致を探る、組み合わせテスト5 - C#ATIA とりあえず、機能するものを先に作りました。 'vba test_FindSingle3DCurve Ver0.0.1 using-'KCL0.08' '単独な3D曲線の取得 Option Explicit '*** 設定 *** Private Const Tolerance = 0.001…

10進数の数値を2進数表記の文字列に変換

VBA

こちらに関係してます。 端点一致を探る、組み合わせテスト5 - C#ATIA段々業務が忙しくなってきたので、思うように取り組めません・・・。どうしても2進数が直ぐにはイメージ出来ない為、確認用の関数を 探してみました。 10進数の値を2進数に変換する(Excei2000以…

端点一致を探る、組み合わせテスト5

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト4 - C#ATIA最初は対象が端点なので、点で考えれば良いと思っていたのですが、 点ではなくボリューム(立方体)として空間分割し、登録しなければ ならない気がしてます。 上手く行かなく苦しんでます。ボリューム…

端点一致を探る、組み合わせテスト3

VBA

こちらの続きです。 端点一致を探る、組み合わせテスト2 - C#ATIA一応、取り組んでますが、全くCATIAとは無関係な状態です。 'vba 'モートン順序を利用した8分木空間分割の為のクズコード Option Explicit Sub CATMain() Dim min: min = Array(-12#, -34#, -56#) '…

3D曲線の端点座標値を取得3

こちらの続きです。 3D曲線の端点座標値を取得2 - C#ATIA 未だにこだわっているのですが、何とかもうちょっと速くしたいので。3D曲線を取得するコードを書くのが面倒だったので、検索で済ませていたのですが 真面目にHybridShapesから探し出すように修正してみ…

3D曲線の端点座標値を取得2

こちらの続きです。 3D曲線の端点座標値を取得 - C#ATIA SPAWorkbenchで端点を取得する方法が、桁違いに速い事はわかったのですが 実際テストしてみると体感的にかなり遅いんです。 その為、形状セットを指定した後の時間を測定するように変更してみました。 'vba …

選択セットを利用し、再選択を高速化

こちらの続きです。 選択セットを利用する - C#ATIA 通勤中に "ひょっとしたら今回使うかも" と思ったので、 選択セットを利用した "再選択の高速化" をテストしてみました。選択セットを作成する際、事前に選択状態にしなければならない為 一度だけでは無意味です。 一…

端点一致を探る、組み合わせテスト1

前回の応用です。 3D曲線の端点座標値を取得 - C#ATIA 3D曲線の端点座標一致を探し出す、組み合わせテストコードを作りました。 予め書いておくと、何も考えずに単純に作っているので全くダメのものです。 少ない量であれば、まぁ大丈夫ですが 数が多いと最悪CATIA…

3D曲線の端点座標値を取得

ご相談頂いた内容を実現する為に、テストコードを作成しました。 3D曲線の端点部分の座標値の取得は、ほぼやったことがありません。2Dの直線であれば、こちらで端点座標を取得しています。 Drawingの直線を移動する2 - C#ATIA 実は、2Dと異なり3Dの場合はプロパティ…

"エリア フィルを修正" コマンドに挑戦

「マクロで "エリア フィルを修正" コマンドを」と御相談を頂いたのですが、難しいです。よくわかっていない物をマクロ化する際に最初に利用するのが、個人的なライブラリ "KCL" のCATMainにしているマクロです。 選択されたものをローカルウィンドウでみて見ると、エリアフィルではなく、Drawing…